/* $Id: inet6_isipv4addr.c,v 1.1.1.1 1996/10/31 12:51:32 pan Exp $
   Determine if an IPv6 address is an IPv4 mapped address.
   Returns TRUE (1) if it is and FALSE (0) if not.
 */

#include <netinet/in.h>
#include <netdb.h>

int inet6_isipv4addr(const struct in6_addr *addr)
{
	unsigned short *ad, *add;

	add = (unsigned short *) addr;
	for (ad = (unsigned short *) addr; (*ad) == 0; ad++);
	/* ad is first non zero position */
	if (ad >= (add + 6)) {
		return (1);
	}
	if ((ad == (add + 5)) && ((*ad) == 0xFFFF)) {
		return (1);
	}
	return (0);
}				/* inet6_isipv4addr */
